package cs636.music.service.data;

import cs636.music.domain.User;

/**
 * User: for service API use: immutable, small
 * contains no private info on the user, like password or credit card info
 * for better security, since its data passes over the Internet in the web app case.
 *
 */
public class UserData {
	private long id;
	private String firstname;
	private String lastname;

	public UserData () {};
	
	public UserData (User u) {
		id = u.getId();
		firstname = u.getFirstname();
		lastname = u.getLastname();
	}
	
	public long getId() {
		return id;
	}

	public String getFirstname() {
		return firstname;
	}

	public String getLastname() {
		return lastname;
	}

}
